{-# LANGUAGE ScopedTypeVariables #-}
module Data.Find.Linear
 ( search, searchM
 ) where

import           Data.Functor.Identity

search :: forall ix a
        . (Ord ix, Num ix, Ord a)
       => (ix -> a) -- ^ Read a value at
       -> (ix, ix) -- ^ (min, max)
       -> a -- ^ The value we're looking for
       -> Maybe ix
search r rng t = runIdentity $ searchM (pure . r) rng t

searchM :: forall m ix a
         . (Monad m, Ord ix, Num ix, Ord a)
        => (ix -> m a) -- ^ Read a value at
        -> (ix, ix) -- ^ (min, max)
        -> a -- ^ The value we're looking for
        -> m (Maybe ix)
searchM r (rmin, rmax) t =
    go rmin rmax
  where
    go :: ix -> ix -> m (Maybe ix)
    go l h | l > h = pure Nothing
    go l h | otherwise = do
      vl <- r l
      if vl == t
      then pure $ Just l
      else go (l+1) h
